/* Exercise 3b.
   Write a C program that reads from the keyboard the elements of an integer
   2-dimension array of 4 rows and 3 columns. Print on the screen the largest
   value resulting from the sum of the values of each column.
*/

#include <stdio.h>

#define ROW 4
#define COL 3

int main(void) {
    int a[ROW][COL];
    int i, j;
    int max, sum;

    /* Read values */
    for(i=0; i<ROW; i++) {
        for(j=0; j<COL; j++) {
            printf("Value (%i, %i): ", i, j);
            scanf("%i", &a[i][j]);
        }
    }

    /* 'On-the-fly' calculation of max */
    
    // First, calculate the sum of the first column,
    // which is the initial max value
    sum = 0;
    for(i=0; i<ROW; i++) {
        sum += a[i][0];
    }
    max = sum;
    
    // Calculate the sum of the j-th column and compare
    // it with the max malue. If the former is larger than
    // the latter, then update max    
    for(j=1; j<COL; j++) {
        sum = 0;

        for(i=0; i<ROW; i++)
            sum += a[i][j];
            
        if(sum > max)
            max = sum;
    }

    /* Print results */
    printf("\nArray: \n");
    for(i=0; i<ROW; i++) {
        for(j=0; j<COL; j++)
            printf("%i ", a[i][j]);
        printf("\n");
    }

    printf("\n\nLargest: \n");
    printf("%i \n", max);

    /* End program */
    system("pause");
    return 0;
}
