/* Exercise 6. 
   Write a C program that declares a 2-dimension array of NxM size -N, M values 
   must be declared as constants. Read the values of the array from the keyboard 
   and print them. Calculate the transpose of the matrix, store the result in a 
   second 2-dimension array, and print the values.
*/

#include <stdio.h>

#define ROWS 2
#define COLS 3

int main(void) {
    /* Declare matrices and indices */
    int m[ROWS][COLS];
    int t[COLS][ROWS];
    int i, j;

    /* Assign values to m */
    for(i=0; i<ROWS; i++) {
        for(j=0; j<COLS; j++) {
            printf("Value (%i, %i): ", i, j);
            scanf("%i", &m[i][j]);
        }
    }

    /* Obtain t values */
    for(i=0; i<ROWS; i++)
        for(j=0; j<COLS; j++)
            t[j][i] = m[i][j];

    /* Print m, t */
    printf("\nMatrix: \n");
    for(i=0; i<ROWS; i++) {
        for(j=0; j<COLS; j++)
            printf("%i ", m[i][j]);
        printf("\n");
    }

    printf("\nTranspose: \n");
    for(i=0; i<COLS; i++) {
        for(j=0; j<ROWS; j++)
            printf("%i ", t[i][j]);
        printf("\n");
    }

    /* End program */
    return 0;
}
