/* Exercise 3.
   Write a C program that reads from the keyboard the elements of an integer
   2-dimension array of 4 rows and 3 columns. Print on the screen the largest
   value resulting from the sum of the values of each column.
*/

#include <stdio.h>

int main(void) {
    int a[4][3];
    int sum[3];
    int i, j;

    /* Read values */
    for(i=0; i<4; i++) {
        for(j=0; j<3; j++) {
            printf("Value (%i, %i): ", i, j);
            scanf("%i", &a[i][j]);
        }
    }

    /* Calculate sum of columns */
    for(j=0; j<3; j++) {
        sum[j] = 0;

        for(i=0; i<4; i++)
            sum[j] += a[i][j];
    }

    /* Calculate largest of sum */
    int max = sum[0];
    for(j=1; j<3; j++)
        if(sum[j] > max)
            max = sum[j];

    /* Print results */
    printf("\nArray: \n");
    for(i=0; i<4; i++) {
        for(j=0; j<3; j++)
            printf("%i ", a[i][j]);
        printf("\n");
    }

    printf("\nSum of columns: \n");
    for(j=0; j<3; j++)
        printf("%i ", sum[j]);

    printf("\n\nLargest: \n");
    printf("%i", max);

    /* End program */
    return 0;
}
