/* Exercise 7. 
   Write a C program to obtain the binary representation of a positive integer value 
   read from the keyboard. The binary representation must be stored in a proper array. 
   (NOTE: Fix an upper threshold to limit the maximum value that can be transformed and 
   stored in the array.) 
*/

#include <stdio.h>
#include <math.h>

#define DIGITS 8

int main(void) {
    /* Declare array for binary representation.
     * The maximum integer value is 2^DIGITS - 1
     */
     int max;
     int b[DIGITS];
     int n;
     int i;

     max = (int) pow(2, DIGITS);

     /* Read integer value */
     do {
        printf("Enter positive integer value in [0, %i): ", max);
        scanf("%i", &n);
     } while(n < 0 || n >= max);

     /* Obtain binary representation */
     for(i=0; i<DIGITS; i++)
        b[i] = 0;

     i = DIGITS-1;
     while(n > 0) {
        b[i] = n % 2;
        n /= 2;
        i--;
     }

     /* Print binary representation */
     printf("\nBinary representation: \n");
     for(i=0; i<DIGITS; i++)
        printf("%i", b[i]);

    /* End program */
     return 0;
}
